import axios from 'axios'
import logger from './logger.js'
// Ignorar erro abaixo, o visual code nao conhece o assert =/
import config from './../../config.json' assert { type: "json" }
const timeout = 1200000

export default {
    post: async function (uri, requestBody, extraOptions = {}) {
        let url = config.enderecoInterface
        url = `${url}backend/service/index.php/${uri}`

        const requestOptions = {
            responseType: 'json',
            ...extraOptions
        }

        return await axios({
            method: 'post',
            url: url,
            data: requestBody,
            timeout,
            ...requestOptions
        })
            .then(successResponse => {
                return (successResponse && successResponse.data) || successResponse;
            })
            .catch(axiosResponse => {
                process.stdout.write(axiosResponse)
                logger.log(axiosResponse)
                throw axiosResponse;
            });
    }
}
