# odhen-taa-base 

> TAA by Teknisa

## Build Setup

``` bash
# install dependencies
npm install

# serve with hot reload at localhost:8080
npm run dev

# build for production with minification
npm run build

# build for production and view the bundle analyzer report
npm run build --report
```

For a detailed explanation on how things work, check out the [guide](http://vuejs-templates.github.io/webpack/) and [docs for vue-loader](http://vuejs.github.io/vue-loader).

## Modal Usage

``` js
Util.showConfirmationDialog(this.$modal, callbackFunction, texto)
```
Or vanilla usage

``` html
<template>
    <modal name="example">This is an example</modal>
</template>

<script>
export default {
    name: 'MyComponent',
    mounted () {
        this.$modal.show('example')
    }
}
</script>
```

```js

    urlOdhenInterface: 'https://odh-interface.teknisa.com/odhen-interface', // Base Jeronimo
    caixaCodigo: '010', // Base Jeronimo
    filialCodigo: 'J035', // Base Jeronimo
    lojaCodigo: '001', // Base Jeronimo

    urlOdhenInterface: 'https://odh-interface.teknisa.com/odhen-interface-jov', // Base Jov
    caixaCodigo: '001', // Base Jov
    filialCodigo: '0001', // Base Jov
    lojaCodigo: '001', // Base Jov

    urlOdhenInterface: 'https://odh-interface.teknisa.com/odhen-interface-giraffas', // Projeto novo com regra de imprime sim / imprime nao
    caixaCodigo: '010', // Base Combo do Combo
    filialCodigo: '0055', // Base Combo do Combo
    lojaCodigo: '0055', // Base Combo do Combo

    urlOdhenInterface: 'https://odh-interface.teknisa.com/odhen-interface-pao', // Base pao de queijo
    caixaCodigo: '012', // Base pao de queijo
    filialCodigo: '0001', // Base pao de queijo
    lojaCodigo: '001', // Base pao de queijo

    urlOdhenInterface: 'https://odh-interface.teknisa.com/odhen-interface-nutrisaude', // Base nutrisaude
    filialCodigo: '1073', // Base nutrisaude
    lojaCodigo: '001', // Base nutrisaude

    urlOdhenInterface: 'https://odh-interface.teknisa.com/odhen-interface-takefive/',
    filialCodigo: '0003',
    lojaCodigo: '001'

    urlOdhenInterface: 'https://odh-interface.teknisa.com/odhen-interface-sesc/', // Base SESC
    filialCodigo: '01',
    lojaCodigo: '0002'
```

O Servidor do SitDemo não permite testar vendas com os dados de TEF reais das lojas.   
Para os testes, é preciso que as configurações codigoTerminalTEF e codLojaTEF utilizem dados de homologação.   
Para isso, nas bases de teste os campos CDTERTEF e CDLOJATEF devem ser updatados para:
```
CDTERTEF = 'CX000000'
CDLOJATEF = '00000000'
```
```sql
UPDATE CAIXA SET CDTERTEF = 'CX000000', CDLOJATEF = '00000000' WHERE IDHABCAIXAVENDA IN ('TAA', 'APC')
```

```sh
%~d0
cd %~dp0
..\assets\nodex64\npm run prod --prefix C:\TEKNISA\taanovo\mobile\static\menuCache
pause

```