/* eslint-disable no-return-await */
import requesModule from '@/assets/libs/requestModule'
import Util from '@/assets/libs/util'

const EVENT_GET_STORE_PRINTERS = 'sale/getStorePrinters'
const EVENT_GET_PRODUCTS_PRINTER = 'menu/getProductsPrinterParams'

// Dados de todas as impressoras da loja que possuem um IP de Periféricos parametrizado
let storePrinters = []
// Dados das impressoras ligadas a cada produto do cardápio
let productsPrinters = []

const getStorePrinters = () => {
    return storePrinters
}

const getProductsPrinters = () => {
    return productsPrinters
}

const fetchStorePrinters = async () => {
    return await requesModule.postRequest(EVENT_GET_STORE_PRINTERS,
        {
            subsidiaryCode: Util.getGeneralInfo()['subsidiaryCode'],
            storeCode: Util.getGeneralInfo()['storeCode']
        }, 'parent')
        .then(res => {
            storePrinters = res.data.printers
        })
}

const fetchProductsPrinters = async () => {
    return await requesModule.postRequest(EVENT_GET_PRODUCTS_PRINTER,
        {
            subsidiaryCode: Util.getGeneralInfo()['subsidiaryCode'],
            storeCode: Util.getGeneralInfo()['storeCode']
        }, 'parent')
        .then(res => {
            productsPrinters = res.data.productsPrinterParams
        })
}

// Busca na Odhen Interface as informações das impressoras parametrizadas, incluindo a relação das
// impressoras de producao para cada produto do cardápio
const syncPrinters = async () => {
    try {
        await fetchStorePrinters()
        await fetchProductsPrinters()
    } catch (error) {
        console.log('Não foi possível carregar a parametrização das impressoras. \nVerifique se o endereço da Odhen Interface foi preenchido corretamente')
    }
}

export default {
    getStorePrinters: getStorePrinters,
    getProductsPrinters: getProductsPrinters,
    syncPrinters: syncPrinters
}
