/* eslint-disable prefer-promise-reject-errors */

const DB_NAME = 'PRODUCTS_STORAGE'
const DB_VERSION = 1

export default {
    async addProdSI () {
        this.addDisabled = true
        // random prodSItem for now
        let prodSItem = {
            name: 'ProdSI' + Math.floor(Math.random() * 100),
            age: Math.floor(Math.random() * 10) + 1
        }
        console.log('about to add ' + JSON.stringify(prodSItem))
        await this.addProdSIToDb(prodSItem)
        this.prodSI = await this.getProdSIsFromDb()
        this.addDisabled = false
    },
    async addProdSIToDb (prodSItem, db) {
        return new Promise((resolve, reject) => {
            let trans = db.transaction(['prodSI'], 'readwrite')
            trans.oncomplete = e => {
                resolve()
            }

            let store = trans.objectStore('prodSI')
            store.add(prodSItem)
        })
    },
    async deleteProdSIFromDb (id, db) {
        return new Promise((resolve, reject) => {
            let trans = db.transaction(['prodSI'], 'readwrite')
            trans.oncomplete = e => {
                resolve()
            }

            let store = trans.objectStore('prodSI')
            store.delete(id)
        })
    },
    async getProdSIsFromDb (db) {
        return new Promise((resolve, reject) => {
            let trans = db.transaction(['prodSI'], 'readonly')
            trans.oncomplete = e => {
                resolve(prodSI)
            }

            let store = trans.objectStore('prodSI')
            let prodSI = []

            store.openCursor().onsuccess = e => {
                let cursor = e.target.result
                if (cursor) {
                    prodSI.push(cursor.value)
                    cursor.continue()
                }
            }
        })
    },
    async getDb () {
        return new Promise((resolve, reject) => {
            let request = window.indexedDB.open(DB_NAME, DB_VERSION)

            request.onerror = e => {
                console.log('Error opening db', e)
                reject('Error')
            }

            request.onsuccess = e => {
                resolve(e.target.result)
            }

            request.onupgradeneeded = e => {
                console.log('onupgradeneeded')
                let db = e.target.result
                db.createObjectStore('prodSI', { autoIncrement: true, keyPath: 'id' })
            }
        })
    },
    async clearDB () {
        window.indexedDB.deleteDatabase(DB_NAME)
    }
}
