/* eslint-disable no-return-await */
import Util from '@/assets/libs/util'

const GET_WEIGHT_PRODUCTS_ENDPOINT = '/menu/getWeightProducts'

const loadData = async function (config) {
    let weighedProds = []
    let weighedProdsRaw = await getWeighedProds(config)
    weighedProds = extractProdsFromGroups(weighedProdsRaw)
    return weighedProds
}

const getWeighedProds = async function (config) {
    const payload = Util.getGeneralInfo()
    return await Util.rawAxiosRequest(config.urlOdhenInterface, true, GET_WEIGHT_PRODUCTS_ENDPOINT, 'post', payload)
        .then(response => response.data || [])
}

const extractProdsFromGroups = function (weighedProdsRaw) {
    let prods = []
    try {
        let hasAnyGroup = weighedProdsRaw && weighedProdsRaw[0] && weighedProdsRaw[0].groups && weighedProdsRaw[0].groups.length > 0
        if (hasAnyGroup) {
            weighedProdsRaw[0].groups.forEach(group => {
                let groupHasProducts = group.products && group.products.length > 0
                if (groupHasProducts) {
                    group.products.forEach(product => {
                        prods.push(product)
                    })
                }
            })
        }
    } catch (error) {
        console.log('Nao foi possivel extrair os produtos pesaveis a partir da resposta recebida da odhen interface')
        prods = []
    }
    return prods
}

export default {
    loadData
}
