import requestModule from './../libs/requestModule.js'
import logger from './../libs/logger.js'
import fs from 'fs'
import {resolve} from 'path'
import moment from 'moment'

let prodCount = 0
let subItemPreSelectedMandatoryList = {}

let prodCounter = function (card) {
    for (let groupIndex = 0; groupIndex < card.data.groups.length; groupIndex++) {
        const group = card.data.groups[groupIndex]

        for (let subProdIndex = 0; subProdIndex < group.subGroups.length; subProdIndex++) {
            const subGroup = group.subGroups[subProdIndex]

            for (let prodIndex = 0; prodIndex < subGroup.products.length; prodIndex++) {
                prodCount = prodCount + 1
            }
        }

        for (let prodIndex = 0; prodIndex < group.products.length; prodIndex++) {
            prodCount = prodCount + 1
        }
    }
    logger.log('Produtos restantes ' + prodCount)
}

let manageProd = async function (prod, config) {
    prodCount--
    if (prodCount % 10 === 0) {
        logger.log('Produtos restantes ' + prodCount)
    }
    if (prod.productGroups.length > 0) {
        let payload = {
            promoProdCode: prod.productCode,
            promoProdGroups: prod.productGroups.map(pg => pg.productGroupCode)
        }

        let preSelectedMandatory = await requestModule.post('v3/menu/getPreselectedProds', payload).then(r => r.data)
        for (let pg = 0; pg < prod.productGroups.length; pg++) {
            const productGroup = prod.productGroups[pg]

            let preSelected = preSelectedMandatory[productGroup.productGroupCode].preSelected
            let mandatory = preSelectedMandatory[productGroup.productGroupCode].mandatory

            for (let pgi = 0; pgi < productGroup.productGroupItems.length; pgi++) {
                const productGroupItem = productGroup.productGroupItems[pgi]

                if (preSelected != null && preSelected.indexOf(productGroupItem.subItemCode) > -1) {
                    prod.productGroups[pg].productGroupItems[pgi].subItemPreSelected = 'S'
                }
                if (mandatory != null && mandatory.indexOf(productGroupItem.subItemCode) > -1) {
                    prod.productGroups[pg].productGroupItems[pgi].subItemMandatory = 'S'
                }

                let promoProdGroups = productGroupItem.subItemProductGroups.map(pg => pg.subProductGroupCode)
                let subitemPayload = {
                    promoProdCode: productGroupItem.subItemCode,
                    promoProdGroups: promoProdGroups
                }

                for (let promoProdGroup = 0; promoProdGroup < promoProdGroups.length; promoProdGroup++) {
                    const promoProdGroupItem = promoProdGroups[promoProdGroup]
                    if (!Object.keys(subItemPreSelectedMandatoryList).includes(`${productGroupItem.subItemCode}${promoProdGroupItem}`)) {
                        let subItemPreSelectedMandatory = await requestModule.post('v3/menu/getPreselectedProds', subitemPayload).then(r => r.data)
                        Object.entries(subItemPreSelectedMandatory).forEach(entries => {
                            let sbopsmkey = entries[0]
                            let sbopsmi = entries[1]
                            subItemPreSelectedMandatoryList[`${productGroupItem.subItemCode}${sbopsmkey}`] = sbopsmi
                        })
                    }
                }
                for (let sbg = 0; sbg < productGroupItem.subItemProductGroups.length; sbg++) {
                    const subItemProductGroup = productGroupItem.subItemProductGroups[sbg]

                    let subitemPreSelected = subItemPreSelectedMandatoryList[`${productGroupItem.subItemCode}${subItemProductGroup.subProductGroupCode}`].preSelected
                    let subitemMandatory = subItemPreSelectedMandatoryList[`${productGroupItem.subItemCode}${subItemProductGroup.subProductGroupCode}`].mandatory

                    for (let sbipgi = 0; sbipgi < subItemProductGroup.subProductGroupItems.length; sbipgi++) {
                        const subProductGroupItem = subItemProductGroup.subProductGroupItems[sbipgi]

                        if (subitemPreSelected != null && subitemPreSelected.indexOf(subProductGroupItem.subItemCode) > -1) {
                            prod.productGroups[pg].productGroupItems[pgi].subItemProductGroups[sbg].subProductGroupItems[sbipgi].subItemPreSelected = 'S'
                        }
                        if (subitemMandatory != null && subitemMandatory.indexOf(subProductGroupItem.subItemCode) > -1) {
                            prod.productGroups[pg].productGroupItems[pgi].subItemProductGroups[sbg].subProductGroupItems[sbipgi].subItemMandatory = 'S'
                        }
                    }

                    let preSelectedMandatoryItens = subItemProductGroup.subProductGroupItems.filter(p => p.subItemMandatory === 'S' && p.subItemPreSelected === 'S')
                    prod.productGroups[pg].productGroupItems[pgi].subItemProductGroups[sbg].subProductGroupItems = preSelectedMandatoryItens.length > 0 ? preSelectedMandatoryItens : subItemProductGroup.subProductGroupItems
                    // if (prod.productGroups[pg].productGroupItems[pgi].subItemProductGroups[sbg].subProductGroupItems && prod.productGroups[pg].productGroupItems[pgi].subItemProductGroups[sbg].subProductGroupItems[0].subItemShowOrder) {
                        prod.productGroups[pg].productGroupItems[pgi].subItemProductGroups[sbg].subProductGroupItems.sort((a, b) => a.subItemShowOrder.replace('|', '') - b.subItemShowOrder.replace('|', ''))
                    // }
                }
            }

            let preSelectedMandatoryItens = prod.productGroups[pg].productGroupItems.filter(p => p.subItemMandatory === 'S' && p.subItemPreSelected === 'S')
            prod.productGroups[pg].productGroupItems = preSelectedMandatoryItens.length > 0 ? preSelectedMandatoryItens : prod.productGroups[pg].productGroupItems
            // if (prod.productGroups[pg].productGroupItems && prod.productGroups[pg].productGroupItems[0].subItemShowOrder) {
                prod.productGroups[pg].productGroupItems.sort((a, b) => a.subItemShowOrder.replace('|', '') - b.subItemShowOrder.replace('|', ''))
            // }
        }
    }

    prod.productSuggestion = await getProductSuggestion(prod.productCode, config)
    return prod
}

let getProductSuggestion = async function (productCode, config) {
    let requestObject = {
        subsidiaryCode: config.subsidiaryCode,
        posCode: config.posCode,
        products: [ productCode ]
    }

    let productSuggestion = await requestModule.post('menu/getProductSuggestion', requestObject).then(r => (r && r.data) || []).catch((e) => [])
    return productSuggestion || null
}

let addPreselected = async function (card, config) {
    if (card.error) {
        logger.log('\n\n' + JSON.stringify(card))
        return card
    }
    logger.log('\n\n' + card.data.groups.length + ' Grupos encontrados no cardapio.')

    for (let groupIndex = 0; groupIndex < card.data.groups.length; groupIndex++) {
        const group = card.data.groups[groupIndex]
        logger.log('Tratando grupo' + group.groupName)
        logger.log((groupIndex + 1) + '/' + card.data.groups.length)

        // if (card.data.groups[groupIndex].products && card.data.groups[groupIndex].products[0].productShowOrder) {
            card.data.groups[groupIndex].products.sort((a, b) => a.productShowOrder.replace('|', '') - b.productShowOrder.replace('|', ''))
        // }

        for (let subProdIndex = 0; subProdIndex < group.subGroups.length; subProdIndex++) {
            const subGroup = group.subGroups[subProdIndex]
            // if (card.data.groups[groupIndex].subGroups[subProdIndex].products && card.data.groups[groupIndex].subGroups[subProdIndex].products[0].productShowOrder) {
                card.data.groups[groupIndex].subGroups[subProdIndex].products.sort((a, b) => a.productShowOrder.replace('|', '') - b.productShowOrder.replace('|', ''))
            // }

            for (let prodIndex = 0; prodIndex < subGroup.products.length; prodIndex++) {
                const product = subGroup.products[prodIndex]
                card.data.groups[groupIndex].subGroups[subProdIndex].products[prodIndex] = await manageProd(product, config)
            }
        }

        for (let prodIndex = 0; prodIndex < group.products.length; prodIndex++) {
            const product = group.products[prodIndex]
            card.data.groups[groupIndex].products[prodIndex] = await manageProd(product, config)
        }
    }
    return card
}

let purgeCache = function () {
    try {
        fs.readdirSync('./cachedMenus/').forEach(file => {
            fs.rmSync(`./cachedMenus/${file}`)
        })
    } catch (error) {
        logger.log('purgeCache - Não hã um cache de cardápio para ser deletado.')
    }
}

let purgeCacheByName = function (file) {
    try {
        fs.rmSync(`./cachedMenus/${file}`)
    } catch (error) {
        logger.log('purgeCacheByName - Não hã um cache de cardápio para ser deletado.')
    }
}

export default {
    purgeCache: () => purgeCache(),
    purgeCacheByName: (file) => purgeCacheByName(file),
    getCachedMenuFile: (posCode) => fs.readFileSync(`./cachedMenus/cachedFoodMenu${posCode}.json`, 'utf-8'),
    manageFoodMenu: async function (cardapio, config, subIPSML = {}) {
        subItemPreSelectedMandatoryList = subIPSML
        if (!(cardapio.data.groups && cardapio.data.groups.length)) {
            logger.log('=============================================================================')
	        logger.log('Não há cardapio para o caixa ' + config.posCode)
            logger.log('=============================================================================')
		return {data: null, subIPSML}
	}
        logger.log('Iniciando tratamento do cardapio ' + config.posCode)
        prodCount = 0
        prodCounter(cardapio)

        let startTime = moment()
        let data = JSON.stringify(await addPreselected(cardapio, config))
        var duration = moment.duration(moment().diff(startTime))
        logger.log(`Tratamento do cardapio para ${config.posCode} durou ${duration.asSeconds()}s`)

        fs.mkdirSync('./cachedMenus', { recursive: true, mode: '0777' })

        let fullPath = resolve(`./cachedMenus/cachedFoodMenu${config.posCode}.json`)
        await purgeCacheByName(`cachedFoodMenu${config.posCode}.json`)
        logger.log(`Cacheando cardapio ${config.posCode}, apos tratamento`)

        fs.writeFileSync(fullPath, data, {flag: 'w'}, (err) => logger(err))
        logger.log(`\n`)
        return {data, subItemPreSelectedMandatoryList}
    }
}
